<template>
  <div>
    <el-card>
      <el-form :model="filterQuery" class="query-form" size="mini" label-width="120px"v-if="showSearch">
        <el-row>
          <el-col :span="11">
            <el-form-item label="UDI:">
              <el-input v-model="filterQuery.udiCode" placeholder="请输入UDI" clearable></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="8">
            <el-form-item label="产品DI:">
              <el-input v-model="filterQuery.relIdFk" placeholder="请输入产品DI" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="标记:">
              <el-input v-model="filterQuery.mark" placeholder="请输入标记" clearable></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col  :span="8">
            <el-form-item label="物资名称:">
              <el-input v-model="filterQuery.cpmctymc" placeholder="请输入物资名称" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col  :span="8">
            <el-form-item label="创建时间:">
              <el-date-picker
                style="width: 100%"
                :picker-options="pickerOptions"
                v-model="actDateRange"
                type="daterange"
                format="yyyy 年 MM 月 dd 日"
                value-format="yyyy-MM-dd"
                range-separator="至"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>

      <div class="top-right-btn">
        <el-button-group style="display:flex;">
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
          <el-button type="primary" icon="el-icon-search" @click="onSubmit">查询</el-button>
          <el-button type="primary" icon="el-icon-plus" @click="addOrderMuti">新增</el-button>
        </el-button-group>
      </div>
      <el-divider style="margin: 15px"></el-divider>


      <el-table v-loading="loading" :data="list" style="width: 100%" @current-change="handleDetail"  border highlight-current-row>
        <el-table-column label="序号" type="index" width="60"></el-table-column>
        <el-table-column label="UDI码" prop="udiCode"></el-table-column>
        <el-table-column label="标记" prop="mark"></el-table-column>
        <el-table-column label="物资名称" prop="cpmctymc"></el-table-column>
        <el-table-column label="规格型号" prop="ggxh"></el-table-column>
        <el-table-column label="总使用次数" prop="totalCount"></el-table-column>
        <el-table-column label="已使用次数" prop="useCount"></el-table-column>
        <el-table-column label="剩余使用次数" prop="reCount"></el-table-column>
        <el-table-column label="批次号" prop="batchNo"></el-table-column>
        <el-table-column label="生产日期" prop="produceDate"></el-table-column>
        <el-table-column label="失效日期" prop="expireDate"></el-table-column>
        <el-table-column label="创建人" prop="createUserName"></el-table-column>
        <el-table-column label="创建时间" prop="createTime"></el-table-column>
        <el-table-column label="状态" prop="status">
          <template slot-scope="scope">
            <el-tag :type="statusFilterType(scope.row.status)">{{ statusMap[scope.row.status] }}</el-tag>
          </template>
        </el-table-column>
        <el-table-column label="操作" width="120px">
          <template slot-scope="scope">
            <el-button type="text" size="small" @click.native.stop="editDialog(scope.row)">编辑</el-button>
            <el-button type="text" size="small" @click.native.stop="deleteDialog(scope.row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="filterQuery.page"
        :limit.sync="filterQuery.limit"
        @pagination="handleCurrentChange"

      ></pagination>
    </el-card>

    <el-card class="el-card">
      <el-table v-loading="loading" :data="detailList" style="width: 100%" border highlight-current-row>
        <el-table-column label="序号" type="index" width="60"></el-table-column>
        <el-table-column label="当前次数" prop="curIndex"></el-table-column>
        <el-table-column label="往来单位" prop="fromCorp" show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="使用人" prop="createUserName" show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="使用时间" prop="useTime" show-overflow-tooltip="true"></el-table-column>
      </el-table>
    </el-card>

    <el-dialog
      :title="formMap[formName]"
      :visible.sync="orderMutiVisible"
      :before-close="close"
      width="60%"
      v-if="orderMutiVisible"
      @close='closeDialog'
      :close-on-click-modal="false"
      :close-on-press-escape="false"
    >
      <ioOrderMutiEditDialog
        :closeDialog="closeDialog"
        :filterQuery="inputQuery"
        :formName="formName"
      ></ioOrderMutiEditDialog>
    </el-dialog>

  </div>
</template>



<script>
import ioOrderMutiEditDialog from "@/views/inout/muti/ioOrderMutiEditDialog";
import {delectMuti, detailMuti, filterList, selectMutiDetailList, selectMutiList} from "@/api/inout/orderMuti";


export default {
  name: "ioOrderMuti",
  data() {
    return {
      showSearch: true,
      filterQuery: {
        udiCode: null,
        orderIdFk: null,
        relIdFk: null,
        mark: null,
        cpmctymc:null,
        totalCount:null,
        useCount:null,
        status:0,
        page: 1,
        limit: 10,
      },
      inputQuery: {
        curInv: null,
        fromCorp: "",
        targetAction: null,
        remark: null,
        updateTime: null,
      },
      total: 0,
      loading: false,
      list: [],
      formName: 1,
      formMap: {
        1: "新增使用出库",
        2: "编辑使用出库",
      },
      statusMap: {
        0: "草稿",
        1: "未审核",
      },

      orderMutiVisible: false,
      actDateRange: [],
      detailList: [],
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
    };
  },
  methods: {
    statusFilterType(status) {
      const statusMap = {
        0: "warning",
        1: "warning",
        2: "danger",
        3: "success",
      };
      return statusMap[status];
    },
    onReset(){
      this.filterQuery={
        udiCode: null,
        orderIdFk: null,
        relIdFk: null,
        mark: null,
        status:0,
        cpmctymc:null,
        page: 1,
        limit: 10,
      }
      this.actDateRange=[]
      this.getList();
      this.detailList=[]
    },
    onSubmit() {
      this.filterQuery.page = 1;
      this.getList();
    },
    handleCurrentChange(val) {
      this.filterQuery.page = val.page;
      this.getList();
    },
    closeDialog(){
      this.orderMutiVisible = false;
      this.getList();
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    addOrderMuti(){
      this.inputQuery={
        udiCode: null,
        orderIdFk: null,
        relIdFk: null,
        mark: null,
      }
      this.formName=1;
      this.orderMutiVisible = true;
    },
    editDialog(row){
      this.formName=2;
      this.inputQuery=row;
      this.orderMutiVisible = true;
    },
    getList() {
      if (this.actDateRange != null) {
        this.filterQuery.startDate = this.actDateRange[0];
        this.filterQuery.endDate = this.actDateRange[1];
      } else {
        this.filterQuery.startDate = null;
        this.filterQuery.endDate = null;
      }
      this.loading = true;
      selectMutiList(this.filterQuery)
        .then((response) => {
          this.loading = false;
          this.list = response.data.list || [];
          this.total = response.data.total || 0;
          this.detailList=[]
        })
        .catch(() => {
          this.loading = false;
          this.list = [];
          this.total = 0;
        });
    },
    deleteDialog(row) {
      delectMuti(row)
        .then((response) => {
          if(response.code == 20000){
            this.getList()
          }else{
            this.$message.error(response.message);
          }
        })
        .catch(() => {
          this.$message.error(response.message);
        });
    },
    handleDetail(row) {
      selectMutiDetailList({mutiIdFk:row.id}).then((response) => {
        if (response.code == 20000) {
          this.detailList = response.data || [];
          this.inputQuery.useCount=this.detailList.length
        }
      })
    },
  },
  components: {ioOrderMutiEditDialog},
  created() {
    this.getList();
  },
}
</script>

<style scoped>

</style>
